;############################################################################
;local.asm - this file is the Local Dll used in my assembler programs
;############################################################################

.586
.model flat,stdcall
option casemap:none

;############################################################################
; The includes section
;############################################################################

        include \masm32\include\windows.inc
	include \masm32\include\shell32.inc
	include \masm32\include\user32.inc
	include \masm32\include\kernel32.inc
	include \masm32\include\gdi32.inc

        includelib \masm32\lib\shell32.lib
        includelib \masm32\lib\user32.lib
        includelib \masm32\lib\kernel32.lib
        includelib \masm32\lib\gdi32.lib

;############################################################################

;############################################################################
;The local prototypes for the functions in the dll
;############################################################################
ExceptionHandler        PROTO
CheckCPU                PROTO

;#################################################################################
;#################################################################################
; BEGIN INITIALIZED DATA
;#################################################################################
;#################################################################################
.data
	;This is just what is placed in the caption of any error messages
        szDLLName       db "CPUID DLL",0

	;The dll instance handle
	hInst		dd 0

	;Used to debug multiple instances
        LoadMsg         db "The DLL is loaded",0
        UnloadMsg       db "The DLL is unloaded",0
        ThreadCreated   db "A thread is created in this process",0
        ThreadDestroyed db "A thread is destroyed in this process",0

	;A bunch of error strings
        NoFPU           db "You don't have an FPU!",0
        NoMMX           db "You don't have MMX!",0
        NotPentium      db "You don't have a pentium CPU!",0
        CPUMsg          db 13 dup (0)

.code
;############################################################################
; Start of DllEntry
;############################################################################
DllEntry proc hInstance:HINSTANCE, reason:DWORD, reserved1:DWORD
	.if reason==DLL_PROCESS_ATTACH
                ;We've loaded the dll, setup any variables and such

                ;If your interested in seeing a message box when it's loaded
                ;put this line in
		;invoke MessageBox,NULL,addr LoadMsg,addr szDLLName,MB_OK

		;Keep the instance incase we need to show an error message
                push hInstance
                pop hInst
	.elseif reason==DLL_PROCESS_DETACH
                ;We've been shut down, so clean up any resources
                ;invoke MessageBox,NULL,addr UnloadMsg,addr szDLLName,MB_OK
	.elseif reason==DLL_THREAD_ATTACH
                ;invoke MessageBox,NULL,addr ThreadCreated,addr szDLLName,MB_OK
	.else        ; DLL_THREAD_DETACH
                ;invoke MessageBox,NULL,addr ThreadDestroyed,addr szDLLName,MB_OK
	.endif
        mov eax, 1      ;return TRUE
        ret
DllEntry Endp
;############################################################################
; End of DllEntry
;############################################################################

;############################################################################
; Start of CheckCPU
;############################################################################
CheckCPU proc
        LOCAL returncode        :DWORD

        invoke SetUnhandledExceptionFilter, Offset ExceptionHandler
        push eax

        mov returncode, NULL
        ;This procedure should check the CPU for MMX and FPU support
        ;and display any error messages and return TRUE or FALSE
        xor eax, eax
        cpuid
        mov DWORD PTR [CPUMsg[0]], ebx
        mov DWORD PTR [CPUMsg[4]], edx
        mov DWORD PTR [CPUMsg[8]], ecx

	;To display a message box with you cpu identification string in it
	;enable this line
        ;invoke MessageBox,NULL,addr CPUMsg,addr szDLLName,MB_OK

        xor eax, eax
        mov eax, 1
        cpuid
        ; This will return ... in eax and
        ; a number of codes in edx
        ;bit 0 is 1 for FPU or 0 if no FPU
        ;bit 23 is 1 for MMX or 0 for no MMX
        push edx
        and edx, 1
        .if edx != 1
                ;We don't have an FPU
                invoke MessageBox,NULL,addr NoFPU,addr szDLLName,MB_OK
                jmp err
        .endif
        pop edx
        shr edx, 23
        and edx, 1
        .if edx != 1
                ;We don't have MMX
                invoke MessageBox,NULL,addr NoMMX,addr szDLLName,MB_OK
                jmp err
        .endif

	;Remember we've got the return value from setting the exception handler
	;on the stack already
        call SetUnhandledExceptionFilter

done:
        ;The CPU supports all of the requested features
        mov eax, 1      ;return TRUE
        ret

err:
        ;Doesn't support the requested features
        mov eax, 0      ;return FALSE
        ret

CheckCPU endp
;############################################################################
; End of CheckCPU
;############################################################################

;############################################################################
; Start of ExceptionHandler
;############################################################################
ExceptionHandler proc
	;Here's the exception handler, this is what is called if the computer
	;does not support the cpuid instruction - like if it was not a pentium
	;machine or some earlier pentiums

	;You could give the option to continue if your game will run on a 
	;486DX4-100Mhz otherwise alert them and then exit

        invoke MessageBox,NULL,addr NotPentium,addr szDLLName,MB_OK
ExceptionHandler endp
;############################################################################
; End of ExceptionHandler
;############################################################################
;############################;
;      End of DLL Code       ;
;############################;
End DllEntry
